include \masm32\include\masm32rt.inc

.data?
hPen          dd ?
hDC           dd ?

hdcH          dd ?
hdcV          dd ?
hbmpH         dd ?
hbmpV         dd ?

DesktopWidth  dd ?
DesktopHeight dd ?
X             dd ?
Y             dd ?
MouseP        POINT <?>

.data

  flag dd 0

.code

DrawLine PROC DC:dword,x1:dword,y1:dword,x2:dword,y2:dword
    invoke MoveToEx,DC,x1,y1,NULL
    invoke LineTo,DC,x2,y2
    ret
DrawLine endp

start:
    invoke GetDC,NULL
    mov hDC,eax
    mov DesktopWidth,rv(GetDeviceCaps,hDC,HORZRES)
    mov DesktopHeight,rv(GetDeviceCaps,hDC,VERTRES)

    ;------------------------------------------------------------------
    ; To simplify the code use a width of 1 for the lines and size the
    ; bitmaps that are used to store the background accordingly.
    ;------------------------------------------------------------------

    invoke CreateCompatibleDC, hDC
    mov hdcH, eax
    invoke CreateCompatibleDC, hDC
    mov hdcV, eax
    invoke CreateCompatibleBitmap, hDC, DesktopWidth, 1
    mov hbmpH, eax
    invoke CreateCompatibleBitmap, hDC, 1, DesktopHeight
    mov hbmpV, eax
    invoke SelectObject, hdcH, hbmpH
    push eax
    invoke SelectObject, hdcV, hbmpV
    push eax


    invoke CreatePen,PS_SOLID,1,0
    mov hPen,eax
    invoke SelectObject,hDC,hPen
    push eax
    .While TRUE
        .If rv(GetAsyncKeyState,VK_ESCAPE)>0
            .break
        .Endif
        invoke GetCursorPos,offset MouseP
        mov eax,MouseP.x
        mov esi,MouseP.y
        .If X!=eax || Y!=esi

            .IF flag

              ;--------------------------
              ; Erase the current lines.
              ;--------------------------

              invoke BitBlt, hDC, 0, Y, DesktopWidth, 1,
                             hdcH, 0, 0, SRCCOPY
              invoke BitBlt, hDC, X, 0, 1, DesktopHeight,
                             hdcV, 0, 0, SRCCOPY
            .ELSE
              inc flag
            .ENDIF

            ;----------------------------------------
            ; Save the background for the new lines.
            ;----------------------------------------

            invoke BitBlt, hdcH, 0, 0, DesktopWidth, 1,
                           hDC, 0, MouseP.y, SRCCOPY
            invoke BitBlt, hdcV, 0, 0, 1, DesktopHeight,
                           hDC, MouseP.x, 0, SRCCOPY

            invoke DrawLine,hDC,0,MouseP.y,MouseP.x,MouseP.y             ;hor Left
            invoke DrawLine,hDC,DesktopWidth,MouseP.y,MouseP.x,MouseP.y  ;hor Right
            invoke DrawLine,hDC,MouseP.x,0,MouseP.x,MouseP.y             ;vert Top
            invoke DrawLine,hDC,MouseP.x,DesktopHeight,MouseP.x,MouseP.y ;vert Bot

        .EndIf
        m2m X,MouseP.x
        m2m Y,MouseP.y
    .EndW

    ;--------------------------
    ; Erase the current lines.
    ;--------------------------

    invoke BitBlt, hDC, 0, Y, DesktopWidth, 1,
                   hdcH, 0, 0, SRCCOPY
    invoke BitBlt, hDC, X, 0, 1, DesktopHeight,
                   hdcV, 0, 0, SRCCOPY

    pop eax
    invoke SelectObject,hDC,eax
    invoke DeleteObject,hPen
    INVOKE ReleaseDC,NULL,hDC

    pop eax
    invoke SelectObject,hdcV,eax
    pop eax
    invoke SelectObject,hdcH,eax
    invoke DeleteObject, hbmpH
    invoke DeleteObject, hbmpV
    invoke DeleteDC, hdcH
    invoke DeleteDC, hdcV

    exit
end start